//SicherungsKopie_502d.js
// 05.04.13 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Erzeugt eine Sicherungskopie
//Basiert auf dem AppleScript "Versioned Save" von Shane Stanley <sstanley@myriad-com.com.au>

// vorsichtshalber die Dialoge einschalten
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// die Funktion aufrufen, welcher die gespeicherten Vorgaben einliest
var defStr = getPrefs();
// die Werte ausziehen
if (defStr != "") {
	var prefVal = defStr.split("\n");
	backupFolder = prefVal[0];
	nVal = prefVal[1]*1;
	sVal = prefVal[2]*1;
}
else {
	backupFolder = "";
	nVal =  5;
	sVal = 10;
}

// wenn kein Dokument geffnet, nur die Vorgaben setzen
if (app.documents.length == 0) {
	askUser();
	exit();
}

// aktuelles Dokument
var curDoc = app.documents[0];

// den Pfad zur Datei speichern
try {
	docPath = curDoc.fullName;
	docName = curDoc.name;
}
catch (e) {
	alert ("Das Dokument speichern.", "Achtung");
	exit();
}

// die Funktion aufrufen, welche den Backup-Ordner prft
var backupFolder = checkForFolder();

if (nVal > 0) {
	var sTag = curDoc.extractLabel("SK_vers_number");
	if (sTag == "" && sTag == "0") {
		curDoc.insertLabel("SK_vers_number", "1");
		var tagAsNum = 1;
		var sTag = "1";
	}
	else {
		var tagAsNum = (sTag*1)+1;
		sTag = "" + tagAsNum;
		curDoc.insertLabel("SK_vers_number", sTag);
	}
	var tagBit = ("00" + sTag).slice(-3);
}
// Name und Suffix speichern
if (docName.indexOf(".indd") != -1) {
	var nameStub = docName.slice(0, -5);
	var curExt   = ".indd";
}
else {
	var nameStub = docName;
	var curExt   = "";
}
// die Backup-Kopie speichern 
try {
	var curName = nameStub + "#" + tagBit + curExt;
	var bkpPath = backupFolder + "/" + curName;
	curDoc.save(new File(bkpPath));
}
catch (e) {
	alert ("Die Backup-Kopie kann nicht gespeichert werden.\nSchreib-Rechte-Problem?", "Achtung");
	exit();
}
// das Dokument berschreiben 
try {
	curDoc.save(new File(docPath));
}
catch (e) {
}

// versuchen, die lteste Datei zu entfernen, sobald die festgelegte Anzahl berschritten ist 
var curDiff = tagAsNum - nVal;
if (curDiff > 0 && curDiff%sVal != 0) {
	var tagBit = ("00" + (tagAsNum-nVal)).slice(-3);
	var nameStub = docName.slice(0, -5);
	var oldFile  = backupFolder + "/" + nameStub + "#" + tagBit + curExt;
	File (oldFile).remove();
}

// den Anwender informieren
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Gespeichert:");
dlog.add("statictext", [80, 100, 320, 116], "\"" + curName + "\"");
dlog.show();
// eine kleine Pause
$.sleep(1500);
// das Fenster schliessen
dlog.close();

// die Funktion, welche die Informationen vorbereitet
function getPrefs() {
	var defStr = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/Sicherung502.txt");
	}
	else {
		var f = new File("~/Library/Preferences/Sicherung502.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			defStr = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return defStr;
}

// die Funktion, welche das Vorhandensein des Ordners prft
function checkForFolder() {
	if (backupFolder == "") {
		backupFolder = askUser();
	}
	else {
		var fo = Folder(backupFolder).exists; 
		if (fo == false) {
			backupFolder = askUser();
		}
	}
	return backupFolder;
}

// die Funktion, welche den Dialog vorbereitet, anzeigt und auswertet
function askUser() {
	// den Ordner auswhlen lassen ...
	var backupFolder = Folder.selectDialog("Den Backup-Ordner whlen");
	if (backupFolder == null) {
		exit();
	}
	// Dialoge lschen, welche offen geblieben sind
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	// den Dialog vorbereiten
	var labelWidth = 135;
	var aDialog = app.dialogs.add({name:"SicherungsKopie"});
	with (aDialog.dialogColumns.add()) {
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Anzahl zu behaltender Versionen:"});
					var numberField = integerEditboxes.add({editValue:nVal, minWidth:36});
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Jede"});
					var skipField = integerEditboxes.add({editValue:sVal, minWidth:36});
					staticTexts.add({staticLabel:". Version nicht lschen"});
					staticTexts.add({staticLabel:" ", minWidth:28});
				}
			}
		}
		with (aDialog.dialogColumns.add()) {
			staticTexts.add({staticLabel:" "});
		}
	}
	// den Dialog anzeigen und auswerten
	var dResult = aDialog.show();
	if (dResult == true) {
		var nValue = numberField.editValue;
		var sValue = skipField.editValue;
		var prefsList = new Array (backupFolder, nValue, sValue);
		var prefString = prefsList.join("\n");
		writeResult(prefString);
		return backupFolder;
	}
	else {
		aDialog.destroy();
		exit();
	}
	aDialog.destroy();
}

// das Ergebnis in eine Datei schreiben
function writeResult(prefString) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/Sicherung502.txt");
	}
	else {
		var f = File("~/Library/Preferences/Sicherung502.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(prefString);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}